@echo off
:: Compile tool for dot (GraphViz) to make a PNG from a dot file
:: AKE 
:: 5:44 PM 5/26/2009
:: Instructions: 2024-02-20---Tue---11:09  
:: To attach to Notepad++ (NPP) as IDE, create Run command:
::  c:\totalcmd\Npp\plugins\graphviz_lite\_AKE_compiler\dot.make.PNG.bat $(NAME_PART)
:: And:
::  c:\totalcmd\IrfanView\i_view32.exe $(NAME_PART).png

if "%1"=="" goto Usage
if "%2"=="" set mode=STD
goto MAIN

:MAIN
:: set executable location
set GVDIR=c:\totalcmd\Npp\plugins\graphviz_lite

:: run unflatten
:: How deep should the tree nodes be allowed to descend from the root? (i.e, how many levels to the layout?)  
:: unflatten depths: 4, 8, 12

set unf_depth=8
echo unflattening graph -- allowing %unf_depth% levels...
:: -f  -c 3   -l 4 makes it 4 levels bended down 
%GVDIR%\unflatten.exe -l %unf_depth% %1.dot > %1.dot2
goto %mode%

:STD
:: run dot
echo rendering %1 using DOT...
%GVDIR%\dot.exe -Tpng %1.dot2 -o %1.png
goto END

:PRUNE
:: prune (remove) subgraphs that hang BELOW named node
:: SELECT node names, as many as wish, but with each prefixed by -n --- DEMONSTRATION is with LanNetwork
set nodes_to_prune=-nbiz_sw -nsw_bse3_16p
echo pruning...
%GVDIR%\prune.exe %nodes_to_prune% %1.dot2 > %1.dotP1
%GVDIR%\dot.exe -Tpng %1.dotP1 -o %1_P1.png
goto END


:: FINISHING THE PROCESS
::  load the %1.png into Paint Shop Pro
:: configure the PSP ruler / grid to INCHES and 5, 5 squares
:: Select, Copy, Paste roughly 11x17" sections of the graph, and save them as the %1_n.png files
:: Load these into Microsoft Picture and Fax Viewer
:: Select and Print  >> MPFV takes care of all of the scaling, rotations, etc.
:: In Fine Print ** (not in MPFV) **, in Options, choose the Paper Source as 11x17" and the Paper Source as Drawer 2 (LD)
:: This will print in 11x17...

:: FINE TUNING
:: fine tune the appearance of the graphs in the source code headers...

:Usage
echo Compile tool for dot (GraphViz) to make a PNG from a dot file
echo written by Assad Ebrahim
echo 5:44 PM 5/26/2009
echo 5/27/2009 - added PRUNE
echo.
echo USAGE
echo dot.make  [filename with no extension] [usage mode: STD or PRUNE]
echo outputs filename.png
echo.
goto END

:END
del %1.dot2
echo Done!


pause
